== Changelog ==

= 3.16.14 =

* FIX: Unsupported operand types: string * int
* freemius library version update

= 3.16.13 =

* FIX: array_slice() expects parameter 1 to be array, null given
* coingecko rate source metadata update

= 3.16.12 =

* Divi theme Checkout error fix
* freemius library version update

= 3.16.11 =

* freemius library version update
* Rate sources metadata update

= 3.16.10 =

* freemius library version update

= 3.16.9 =

* Rate sources metadata update
* freemius library version update

= 3.16.8 =

* Rate sources metadata update

= 3.16.7 =

* null transaction receipt return fixed

= 3.16.6 =

* `wpdb::prepare` usage fixed

= 3.16.5 =

* `ethprice_api_url` setting fix

= 3.16.4 =

* `wpdb::prepare` usage fixed

= 3.16.3 =

* `woocommerce/action-scheduler` versions conflict prevention
* freemius library version update

= 3.16.2 =

* Fix the `Call to undefined function ethereum_wallet_freemius_init` error

= 3.16.1 =

* Fix unset key usage issue on the settings page

= 3.16.0 =

* The MultiSend contract is used to process many ERC20 orders at once.
* Blockchain settings configuration is simplified for both, infura.io supported and custom networks

= 3.15.15 =

* Warning fix for PHP v8

= 3.15.14 =

* `sepolia` testnet support is added
* `goerli` testnet support is added

= 3.15.13 =

* The `Ethereum Address` field validation and requirement UX unified with the default WooCommerce way

= 3.15.12 =

* Register on checkout is supported without address input requirement
* `woocommerce/action-scheduler` update to the 3.5.1

= 3.15.11 =

* Helper method for the [ERC20 Dividend Payments Add-On](https://ethereumico.io/product/erc20-dividend-token-payments/) is added

= 3.15.10 =

* Exchange dictionaries updated

= 3.15.9 =

* Checkout billings fileds fix for non-crypto products

= 3.15.8 =

* Add-ons prices display fix

= 3.15.7 =

* Fix order processing issue

= 3.15.6 =

* Lost `vendor/bitwasp` folder in free version is restored

= 3.15.5 =

* Virtual checkbox shows Crypto settings fix
* coingecko dictionary updated

= 3.15.4 =

* coingecko dictionary updated

= 3.15.3 =

* Security fix

= 3.15.2 =

* Dictionaries updated

= 3.15.1 =

* `bignumber.js` minified file was not added to zip

= 3.15.0 =

* [WCFM](https://ethereumico.io/product/wcfm-marketplace-cryptocurrency-addon/) plugin support is added

= 3.14.8 =

* coingecko free API rate limit fix

= 3.14.7 =

* coingecko dictionary updated

= 3.14.6 =

* New freemius.com library version

= 3.14.5 =

* Rate sources updated

= 3.14.4 =

* Handle situation when tx is disappeared, or the node used is outdated. Order status is set to `Failed` and tx hash is cleaned to allow admin to restart order processing.
* Allow zero total orders. Useful for 100% discount codes use case.
* Ethereum address validation check fix.

= 3.14.3 =

* Better tip calculation for EIP-1559 blockchains.

= 3.14.2 =

* Rate source dictionaries updated

= 3.14.1 =

* Fix for the `'NumberUtil' not found` error

= 3.14.0 =

* [polygon](https://polygon.technology/) and [mumbai](https://mumbai.polygonscan.com/) testnet support
* WooCommerce `action-scheduler` [issue workaround](https://github.com/woocommerce/action-scheduler/issues/730#issuecomment-880586544)

= 3.13.10 =

* `action-scheduler` lib update

= 3.13.9 =

* Do not send a transaction if order's total is zero

= 3.13.8 =

* Fix for non-EIP-1559 blockchains.

= 3.13.7 =

* Better support for non-EIP-1559 blockchains.

= 3.13.6 =

* EIP-1559 issue fix.

= 3.13.5 =

* Quick "dirty" fix for the EIP-1559 issue. It leads to unnecessarily high gas fees paid, but enables plugin to send tx at least.

= 3.13.4 =

* RLP library update to fis the "could not decode RLP components" error

= 3.13.3 =

* fix dynamic price hook error

= 3.13.2 =

* WooCommerce 5.5.0 `action-scheduler` [fix](https://github.com/woocommerce/action-scheduler/issues/730#issuecomment-880586544)

= 3.13.1 =

* fix cart access error

= 3.13.0 =

* Single crypto product in order limitation is removed!
* Dynamic price logic rewrite
* New quantity calculation algorithm
* [kanga.exchange](https://kanga.exchange/) rate source disabled due to API down
* Rate sources dictionaries updated

= 3.12.3 =

* WC hook handlers to better support the `Trading history` feature in the [NFT WordPress Plugin](https://ethereumico.io/product/nft-wordpress-plugin/)

= 3.12.2 =

* Make crypto products always require processing
* Fix library version to avoid conflicts

= 3.12.1 =

* Library versions upgrade to avoid conflicts

= 3.12.0 =

* Utility functions to support the `Trading history` feature in the [NFT WordPress Plugin](https://ethereumico.io/product/nft-wordpress-plugin/)

= 3.11.0 =

* New settings added to change Ethereum, Ether and ETH strings to BNB if Binance Smart Chain blockchain is used
* Ether and/or ERC20 product types can be disabled in plugin settings

= 3.10.14 =

* `could not decode RLP components` fix for ERC20 token

= 3.10.13 =

* `could not decode RLP components` fix

= 3.10.12 =

* Invalid RLP issues fix

= 3.10.11 =

* Variable products processing support is added

= 3.10.10 =

* Fix ERC20 token address field display in multi vendor mode

= 3.10.9 =

* Correct gas estimation for all transactions

= 3.10.8 =

* `Call to a member function get_id() on bool` fix

= 3.10.7 =

* Auction plugin support

= 3.10.6 =

* Ignore temporal API errors when asking for tx status to not send new tx while previous one is not confirmed yet.

= 3.10.5 =

* Fix for `Call to undefined method WP_Post::get_id()`

= 3.10.4 =

* Proper big integers handling in web3 calls arguments

= 3.10.3 =

* Proper woocommerce hooks calling to fix WC Vendor issues
* Library versions update

= 3.10.2 =

* Proper seller wallet selection in a multi-vendor case
* Pre-fill address field even if `jQuery` is not defined

= 3.10.1 =

* Custom blockchain feature `basic auth` URLs fix
* `web3.js` library version update to overcome firefox issues
* Rate sources metadata updated

= 3.10.0 =

* The `Require enough Ether on a Checkout page?` configuration setting is added
* PHP libraries used are updated

= 3.9.0 =

* The [coingecko.com](https://www.coingecko.com/) rate source is added

= 3.8.4 =

* Add 10% of the $minimumStep to workaround price fluctuations. (Errors like "Product quantity 0.99937095862906 less then the minimum allowed: 1.")

= 3.8.3 =

* Allow order quantity edit for fixed price products

= 3.8.2 =

* Exchanges currency dictionaries updated
* Try the reverted currency route conversion for cryptocompare.com if the direct one does not exists

= 3.8.1 =

* Dynamic ETH or ERC20 token price mode fix
* `requires 64 bit` activation check is added

= 3.8.0 =

* `Expiration period` configuration option is added

= 3.7.9 =

* `Input in store currency` option store fix

= 3.7.8 =

* Fiat rate display fix for [Wordpress Ethereum Wallet](https://ethereumico.io/product/wordpress-ethereum-wallet-plugin/) integration

= 3.7.7 =

* `Minimum amount` field fix for static price products

= 3.7.6 =

* Kanga exchange token rate fix

= 3.7.3 =

* Null cart error fix (yith-woocommerce-anti-fraud-premium plugin compatibility)

= 3.7.2 =

* `Input in fixed store currency` option sent quantity amount fix

= 3.7.1 =

* `Input in fixed store currency` option fix

= 3.7.0 =

* `Input in fixed store currency` option is added to a product. It allows to create product with fixed price like 100$, but with a dynamic amount of cryptocurrency to be sent after this product purchase.

= 3.6.2 =

* "Warning: A non-numeric value encountered" fix

= 3.6.1 =

* Metals-api.com rate source fix for non-USD currencies

= 3.6.0 =

* Metals-api.com rate source is added. Token price can be bound to a gold for example.

= 3.5.9 =

* Display `Crypto Tx Hash` field in emails if not empty

= 3.5.8 =

* Display `Crypto Wallet Address` field in emails

= 3.5.7 =

* Ask eth node for gas price if API returns zero
* Cache token decimals call results

= 3.5.6 =

* Cancel order processing if it's state is not `processing`

= 3.5.5 =

* show text input if token list is empty. the no Ethereum Wallet PRO installed case

= 3.5.4 =

* product publish fee fix for multi-vendor

= 3.5.3 =

* `post_author_override` fix for multi-vendor

= 3.5.2 =

* cart price display fix

= 3.5.1 =

* kanga.exchange rate source fix

= 3.5.0 =

* kanga.exchange rate source is added

= 3.4.0 =

* Cryptocompare.com rate source is added

= 3.3.1 =

* Price display fix

= 3.3.0 =

* The [WC Vendors Marketplace](https://wordpress.org/plugins/wc-vendors/) plugin integration

= 3.2.0 =

* `Ethereum Node JSON-RPC Endpoint` admin setting is added to allow your own Ethereum or Ethereum fork node usage.

= 3.1.1 =

* Fix Total for extra charges plugins
* Fix bug with price display

= 3.1.0 =

* Check requirements before the [freemius.com](https://freemius.com) code to prevent failures
* infura.io, geth, non-logged MetaMask [fix](https://github.com/INFURA/infura/issues/189#issuecomment-535937835)
* The `Hot wallet` private key is auto generated first time plugin is installed
* Previous `Hot wallet` private key is stored in a hidden option object when new one is entered. This feature can save your life, seriously ;-)

= 3.0.4 =

* Max value bug fix

= 3.0.3 =

* ERC20 Dividend Payment support fix

= 3.0.2 =

* ERC721 support fix

= 3.0.1 =

* bug fix

= 3.0.0 =

* [freemius.com](https://freemius.com) Free/Professional plans business model shift

= 2.7.0 =

* Bitcoin addon support
* General addons infrastructure implemented

= 2.6.0 =

* `Input in store currency` option is added in product settings: input product price in the store currency like USD, instead of the cryptocurrency selected

= 2.5.1 =

* Small usability fixes for display base cryptocurrency price feature

= 2.5.0 =

* Display base cryptocurrency price for dynamically priced products option is added

= 2.4.0 =

* Dynamic ETH or ERC20 token price from Coinmarketcap.com can be configured

= 2.3.7 =

* [ERC20 Dividend Payments WordPress plugin](https://ethereumico.io/product/erc20-dividend-payments/) support is added

= 2.3.6 =

* Register on checkout fix

= 2.3.5 =

* ERC223 fix

= 2.3.4 =

* Infura.io legacy API authentication [deprecation](https://blog.infura.io/infura-dashboard-transition-update-c670945a922a)

= 2.3.3 =

* Allow 10^-18 minimal value and step in all numerical fields. Very special requirement from the [Priceless](https://whatispriceless.com/) project.

= 2.3.2 =

* Gracefully fail order if insufficient funds detected
* Detect tx failure and set corresponding order status to failed

= 2.3.1 =

* New plugin version is not shown for the PRO now
* One-minute offset is added for failed task restart to lower server CPU usage

= 2.3.0 =

* The `Ethereum Address` input box on the `Add new order` page integrated with the [Ethereum Wallet](https://wordpress.org/plugins/ethereum-wallet/) plugin.
* mbstring PHP module check is added on plugin activation
* Load scripts only on the `product edit` page

= 2.2.0 =

* The `Ethereum Address` input box is added to the `Add new order` page. Manually created orders can send tokens now.

= 2.1.8 =

* Complete `prospress/action-scheduler` library upgrade

= 2.1.7 =

* Upgrade web3.js to the latest stable release v0.20.6

= 2.1.6 =

* Fix tx confirmation check

= 2.1.5 =

* Fix mycryptocheckout compatibility problem
* Downgrade bitwasp/buffertools to 0.4.X (bitwasp/bitcoin 0.0.35.X dependency)

= 2.1.4 =

* German locale by Johannes from decentris dot com

= 2.1.3 =

* Fix uninitialized settings warnings for some strict PHP installations

= 2.1.2 =

* Fix rounding problem for deposit amount field
* Fix disabled -> readonly for address field

= 2.1.1 =

* Check for PHP version before the `autoload.php` file inclusion to prevent errors for PHP 5.X versions

= 2.1.0 =

* The Ethereum Gas price is auto adjusted according to the [etherchain.org](https://www.etherchain.org) API
* Check for the gmp PHP module is added on the plugin activation
* js error on pages with no WordPress Ethereum Wallet plugin shortcodes is fixed
* additional protection against double send

= 2.0.2 =

* The transactions serialization queue is implemented to safely increase the nonce value on a high traffic

= 2.0.1 =

* The [0x00 nonce](https://github.com/web3p/ethereum-tx/issues/15) error is fixed
* Long wait for low gas price admin transactions is fixed: set the Gas price to be >= 11Gwei for admin transactions
* The Ether deposit now preserves at least 0.01 Ether on the wallet to pay Ethereum transaction fees

= 2.0.0 =

* Pure PHP Ethereum tx sign implementation. All glory for [Kuan-Cheng,Lai](https://github.com/sc0Vu) here. It simplifies installation procedure dramatically
* Minor fixes

= 1.1.0 =

* Custom user meta key can be configured to fill the `Ethereum address` field automatically. With a plugin like [Ultimate Member](https://ru.wordpress.org/plugins/ultimate-member/) you can configure your registartion form to include a required `Ethereum address` field. You can use this address on a checkout page then.
* You also can disable the `Ethereum address` field to restrict user to buy only to the address they provide you on registration.
* The quantity increase/decrease step is configured per product

= 1.0.0 =

* Initial public release
